package es.logmeal.sdk;

import java.util.ArrayList;
import java.util.List;

public class AngleRange {
    private final int numFrames = 100;
    private final double start = 50.0;
    private final double end = 130.0;

    public List<double[]> getRanges() {

        double step = (end - start) / (numFrames);
        List<double[]> doubleArrayList = new ArrayList<>();
        double current = start;
        while ((current <= end) && (doubleArrayList.size() < (numFrames))) {
            double[] array = {current, current + step};
            doubleArrayList.add(array);
            current += step;
        }
        for (double[] array : doubleArrayList) {
            System.out.println("[" + array[0] + ", " + array[1] + "]");
        }
        return doubleArrayList;
    }
    public double[] binarySearch(List<double[]> subarrays, double target) {
        if (target < 0) return null;
        int left = 0;
        int right = subarrays.size() - 1;

        while (left <= right) {
            int mid = left + (right - left) / 2;
            double[] current = subarrays.get(mid);

            if (target >= current[0] && target <= current[1]) {
                return new double[]{mid, current[0], current[1]};
            } else if (target < current[0]) {
                right = mid - 1;
            } else {
                left = mid + 1;
            }
        }

        return null; // Subarray not found
    }
}
