package es.logmeal.sdk;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

public class FrameDepthInfo {

    private final ProcessedRgbImg processedRgbImg;
    private final CameraInfo cameraInfo;
    private final Long timestamp;

    public FrameDepthInfo(

            ProcessedRgbImg imageData,
            CameraInfo cameraInfo,
            Long timestamp) {

        this.processedRgbImg = imageData;
        this.cameraInfo = cameraInfo;
        this.timestamp = timestamp;
    }



    public ProcessedRgbImg getProcessedRgbImg() {
        return processedRgbImg;
    }

    public CameraInfo getCameraInfo() {
        return cameraInfo;
    }

    public Long getTimestamp() { return timestamp; }

    public String toJson() {
        Gson gson = new GsonBuilder()
                .registerTypeAdapter(DepthImage.class, new DepthImage.DepthImageSerializer())
                .registerTypeAdapter(ProcessedRgbImg.class, new ProcessedRgbImg.ProcessedRgbImgSerializer())
                .create();
        return gson.toJson(this);
    }

    public String toPrettyJson() {
        Gson gson = new GsonBuilder()
                .registerTypeAdapter(ProcessedRgbImg.class, new ProcessedRgbImg.ProcessedRgbImgSerializer())
                .setPrettyPrinting()
                .create();
        return gson.toJson(this);
    }
}
